/**
 * Audio Mixer, it accepts audio from the stero line-in and the mono microphone inputs and
 * mixes the two signals and plays them on one of the line outs.
 *
 * The ac97_controller_4.0 was taken from the realtime project from 2005
 *
 * TEST CODE
 */

#include "stdio.h"
#include "xparameters.h"
#include "fsl.h"
#include "xac97.h"
#include "xac97_l.h"
#include "xac97_i.h"

//#define SAMPLE_RATE 44100
#define SAMPLE_RATE 22000


#define INCOMING_FSL_ID 0		//codec to microblaze
#define MIX_INCOMING_FSL_ID	1	//microblaze to mixer

#define MIX_OUTGOING_FSL_ID	1 	//mixer to microblaze
#define OUTGOING_FSL_ID 0		//microblaze to codec



int main(void) {

	Xuint32 soundbyte = 0;
	Xuint32 soundbyte2 = 0;
	int mix = 50;

	//Step 1: Initialize the AC97 registers
	xil_printf("Initializing Sound\r\n");
	init_sound(SAMPLE_RATE);


	//TODO: look into which input is configured, try to configure both inputs


	//Step 2: Enable playback and record function on the AC97 controller
	xil_printf("Enable Playback and Record\r\n");

	playback_enable();
	record_enable();


	//Using FSL: (use the Fast Simplex Link Interface Macros)

	while (1) {

		//Record:
		getfsl(soundbyte, INCOMING_FSL_ID);	//line_in
		getfsl(soundbyte2, INCOMING_FSL_ID);	//mic_in

		putfsl(soundbyte, OUTGOING_FSL_ID);
	}


	//disable the functions,
	playback_disable();
	record_disable();

	xil_printf("Disable Playback and Record");

}




