/**
In case you have problems with the external memory,

Check the XIo_In32 and XIo_Out32 operations to access memory.


*/

/**
 * Audio Mixer, it accepts audio from the stero line-in and the mono microphone inputs and
 * mixes the two signals and plays them on one of the line outs.
 *
 * The ac97_controller_4.0 was taken from the realtime project from 2005
 *
 */

#include "stdio.h"
#include "stdlib.h"
#include "time.h"
#include "xbasic_types.h"
#include "xparameters.h"
#include "fsl.h"
#include "xintc.h"
#include "xuartlite.h"
#include "xac97.h"


#define printf xil_printf

#define ASCII_NUM_0 48
#define ASCII_NUM_1 49
#define ASCII_NUM_2 50
#define ASCII_NUM_3 51
#define ASCII_NUM_4 52
#define ASCII_RIGHT_ARROW 44	//TODO
#define ASCII_LEFT_ARROW 46		//TODO
#define MIX_RATION_GAIN 2.0
#define MIXER_ECHO_SIGNAL_ON 666
#define MIXER_ECHO_SIGNAL_OFF 777

//#define SAMPLE_RATE 44100
#define SAMPLE_RATE 22000

#define INCOMING_FSL_ID_LEFT 1
#define OUTGOING_FSL_ID 0
#define INCOMING_FSL_ID_RIGHT 2
#define MIXER_IN_FSL_ID_LEFT 3
#define MIXER_IN_FSL_ID_RIGHT 4
#define MIXER_OUT_FSL_ID 5

#define TRUE 1
#define FALSE 0

int cmd_choice = 0;
int perform_action = 0;
float mix_ratio_left = 50.0;
float mix_ratio_right = 50.0;


void print_menu() {
	printf("1. Mix Signals\r\n");
	printf("2. Apply Echo\r\n");
	printf("3. Apply Effect #2\r\n");
	printf("4. Stop\r\n\r\n");
	fflush(stdout);
}

// adjust the mixing rate of signals
void adjustMixRatio(int c) {

	//increase mix of that signal
	if (c == ASCII_RIGHT_ARROW) {
		mix_ratio_right = ((mix_ratio_right + MIX_RATION_GAIN) <= 100)? mix_ratio_right + MIX_RATION_GAIN: mix_ratio_right;
		mix_ratio_left = ((mix_ratio_left - MIX_RATION_GAIN) >= 0)? mix_ratio_left - MIX_RATION_GAIN: mix_ratio_left;
	} //left arrow
	else if (c == ASCII_LEFT_ARROW) {
		mix_ratio_right = ((mix_ratio_right - MIX_RATION_GAIN) >= 0)? mix_ratio_right - MIX_RATION_GAIN: mix_ratio_right;
		mix_ratio_left = ((mix_ratio_left + MIX_RATION_GAIN) <= 100)? mix_ratio_left + MIX_RATION_GAIN: mix_ratio_left;
	}

	printf("Adjusting Ratios R:%d, L:%d\r\n", mix_ratio_right, mix_ratio_left);
}

// determine which arrow was selected and what the resulting mix sound ratio is
int isMixingRatio(int c) {	//TODO: fix it

	//right arrow
	if (c == ASCII_RIGHT_ARROW || c == ASCII_LEFT_ARROW) {
		return TRUE;
	}
	return FALSE;
}

//check if the comman being
int isCommandChoice(int c, int choice) {
	if (choice == c) { return 1; }
	return 0;
}

void mixMusic(int activateEcho, int activateEffect) {

	Xuint32 soundbyte_left;
	Xuint32 soundbyte_right;
	Xuint32 soundbyte_out;

	//send signals from codec to the mixer
	//printf("Read from AC97 through FIFO\r\n");
	//getfsl(soundbyte_left, INCOMING_FSL_ID_LEFT);		//left
	//getfsl(soundbyte_right, INCOMING_FSL_ID_RIGHT);		//right
	ngetfsl(soundbyte_right, 1);
	ngetfsl(soundbyte_left, 1);

	printf("data: %d.%d ", soundbyte_left,soundbyte_right);

	//printf("send config command to mix component, include mix ratio and start, stop\r\n");
	//microblaze_bwrite_cntlfsl((Xuint16)mix_ratio_left, MIXER_IN_FSL_ID);   	//mix ration right can be inferred
	//TODO: should I be sending data right after the command??
	//microblaze_bwrite_datafsl(soundbyte_left, MIXER_IN_FSL_ID_LEFT);
	//microblaze_bwrite_datafsl(soundbyte_right, MIXER_IN_FSL_ID_RIGHT);


	if (activateEcho) {
		printf("send command to mixer to start buffering to create an echo\r\n");
		//microblaze_bwrite_cntlfsl((Xuint16)MIXER_ECHO_SIGNAL_ON, MIXER_IN_FSL_ID);	//signal echo
		//TODO: should I be sending data
	} else {
		printf("send command to mixer to stop buffering for echo\r\n");
        //microblaze_bwrite_cntlfsl((Xuint16)MIXER_ECHO_SIGNAL_OFF, MIXER_IN_FSL_ID);	//signal echo
		//TODO: should I be sending data
	}

	if (activateEffect) {


	} else {


	}

	//microblaze_bread_datafsl(soundbyte_out, MIXER_OUT_FSL_ID);
	//printf("Read signal from mixer\r\n");

	//receive signals from the mixer and put them in the codec
	//putfsl(soundbyte_right, OUTGOING_FSL_ID);
	putfsl(soundbyte_right, 0);
	//printf("Send signal to AC97\r\n");

}


XIntc InterruptController;
XUartLite UartController;
XAC97 codec;

int main(void) {

	XStatus Status;
	int choice = -1;

	/********** SetUp UartLite **************************/
	Status = XUartLite_Initialize(&UartController, XPAR_RS232_UART_1_DEVICE_ID);
	if (Status != XST_SUCCESS) {
		printf("Uart initialization error\n\r\r");
    }

    XUartLite_ResetFifos(&UartController);

	Status = XUartLite_SelfTest(&UartController);
	if (Status != XST_SUCCESS) {
        printf("Uart self-test error\n\r");
    }

    /*
     * clears whatever is in the fifos
     */
    //XUartLite_ResetFifos(&UartController);	//TODO: perhaps it should be done somewhere else

	printf("Application Started\n\r\r");

	/*
	 * Only set-up a function that listens for received interrupts.
	 */
//	XUartLite_SetRecvHandler(&UartController, (XUartLite_Handler)uartIntcHandler,
//                              &UartController);

	/*
	 * Enable interrupts.
	 */

//	XUartLite_InterruptHandler(&UartController);
//
//	XUartLite_EnableInterrupt(&UartController);

	/********** Set-up the Interrupts *******************/

	/*
     * Initialize the interrupt controller driver so that it's ready to use,
     * using the device ID that is generated in xparameters.h
     */
	Status = XIntc_Initialize(&InterruptController, XPAR_OPB_INTC_0_DEVICE_ID);
    if (Status != XST_SUCCESS) {
        printf("Interrupt controller initialization error\n\r");
    }

	/*
     * Connect the device driver handler that will be called when an interrupt
     * for the device occurs, the device driver handler performs the specific
     * interrupt processing for the device
     */
	Status = XIntc_Connect(&InterruptController, XPAR_OPB_INTC_0_DEVICE_ID,
                      (XInterruptHandler)XUartLite_InterruptHandler, &UartController);
	if (Status != XST_SUCCESS)
    {
        printf("Interrupt controller connect error\n\r");
    }

	/*
     * Start the interrupt controller so interrupts are enabled for all
     * devices that cause interrupts. Specify real mode so that the timer
     * counter can cause interrupts through the interrupt controller.
     */
   	Status = XIntc_Start(&InterruptController, XIN_REAL_MODE);
   	if (Status != XST_SUCCESS)
   	{
        printf("Interrupt controller start error\n\r");
   	}

    /* Enable the interrupt for the timer counter and enable interrupts in
     * the microblaze processor
     */
   	XIntc_Enable(&InterruptController, XPAR_OPB_INTC_0_DEVICE_ID);


	/**** initialize sound *****/
	Status = XAC97_Initialize(&codec, XPAR_OPB_AC97_CONTROLLER_0_DEVICE_ID);
	if (Status != XST_SUCCESS)
   	{
        printf("Could not initialize AC97 Registers.\n\r");
   	}

    Status = XAC97_SelfTest(&codec);
    if (Status != XST_SUCCESS)
    {
        printf("AC97 Self-Test failed.\n\r");
    }
	init_sound(SAMPLE_RATE);

	playback_enable();
	record_enable();

	microblaze_enable_interrupts();

	print_menu();	//print the menu

    //foreground processing
	while (1) {
		Xuint8 c = -1;

		//c = getchar();
		XUartLite_Recv(&UartController, &c, 1);

		//convert char to a number
		if (c != -1) {
			choice = atoi(&c);
			//printf("The choice is: %d and original %c\n\r",choice, c);
		}

		//current state of the
		switch(cmd_choice) {
			case 0:
				// check if a selection from the main menu was made
				// only case 1 is acceptable, the rest display an error
				if (isCommandChoice(choice, 1) ) {
					printf("-----=== Begin Mixing ===-----\r\n");
					perform_action = 1;
					cmd_choice = 1;
					mixMusic(FALSE, FALSE);
				} else {
					//printf("To start select option 1.\n\r");
				}

				break;
			case 1:
				// 1. allow for the arrow keys to prove direction in terms of which signal should be heard louder
				// display the percentage of the mixing (start at 50%)
				// if a choice from the menu is selected implement it

				if (isCommandChoice(choice, 2) ) {	//is echo
					printf("-----=== Add Echo ===-----\r\n");
					perform_action = 2;
					cmd_choice = 2;
					mixMusic(TRUE, FALSE);
				} else if (isCommandChoice(choice, 3)) {	//is effect
					printf("-----=== Start Effect ===-----\r\n");

					mixMusic(FALSE, TRUE);
				} else if (isCommandChoice(choice, 4)) {	//is stop
					printf("-----=== Stop Mixing ===-----\r\n");
					perform_action = 0;
					cmd_choice = 0;
					print_menu();
				} else if (isMixingRatio(c)) {	//is change in ratio
					adjustMixRatio(c);
					mixMusic(FALSE, FALSE);
				} else {
					mixMusic(FALSE, FALSE);
				}
				break;
			case 2:

				// 2. make sure that signal mixing is already turned on
				// make a call for the echo to be applied
				// disply the choice

				//is echo then stop it
				if (isCommandChoice(choice, 2) ) {
					printf("-----=== Stop Echo ===-----\r\n");
					perform_action = 1;
					cmd_choice = 1;
					mixMusic(FALSE, FALSE);
				} else if (isCommandChoice(choice, 3)) {	//is stop
					printf("-----=== Stop Echo, Start Effect ===-----\r\n");
					perform_action = 3;
					cmd_choice = 3;
					mixMusic(FALSE, TRUE);
				} else if (isCommandChoice(choice, 4)) {	//is stop
					printf("-----=== Stop Mixing ===-----\r\n");
					perform_action = 0;
					cmd_choice = 0;
					print_menu();
				} else if (isMixingRatio(c)) {	//is change in ratio
					adjustMixRatio(c);
					mixMusic(TRUE, FALSE);
				} else {
					mixMusic(TRUE, FALSE);
				}

				break;

			case 3:
				// 3. make sure that the signal mixing is already turned on
				// apply the 2nd effect
				// display the choice
				if (isCommandChoice(choice, 2) ) {
					printf("-----=== Stop Effect, Start Echo ===-----\r\n");
					perform_action = 2;
					cmd_choice = 2;
					mixMusic(TRUE, FALSE);
				} else if (isCommandChoice(choice, 3)) {	//is stop
					printf("-----=== Stop Effect ===-----\r\n");
					perform_action = 1;
					cmd_choice = 1;
					mixMusic(FALSE, TRUE);
				} else if (isCommandChoice(choice, 4)) {	//is stop
					printf("-----=== Stop Mixing ===-----\r\n");
					perform_action = 0;
					cmd_choice = 0;
					print_menu();
				} else if (isMixingRatio(c)) {	//is change in ratio
					adjustMixRatio(c);
					mixMusic(FALSE, TRUE);
				} else {
					mixMusic(FALSE, TRUE);
				}
				break;
			default:
				//not a valid choice
				//print to the screen?
				printf("Please select a function from the menu.\n\n\r\r");
				print_menu();
		}
	}

	//playback_disable();
	//record_disable();

   //disable interrupts, TODO: not sure if necessary
   //void XUartLite_DisableInterrupt(&UartController);
}

//initialize the interrupt system to wait for a command from the keyboard on the Uart

//switch to the appropriate part of the code given the command
//indicate in the global statement which command is selected


//TODO: would selecting apply echo twice stop it?


