# Compile and show
vlog audio_mixer.v
vsim {-voptargs=+acc} audio_mixer

#add waves
view wave
add wave -noupdate -format Logic -radix binary /audio_mixer/FSL_Clk
add wave -noupdate -format Logic -radix binary /audio_mixer/FSL_Rst
add wave -noupdate -format Literal -radix binary /audio_mixer/FSL_S_Read
add wave -noupdate -format Literal -radix hexadecimal /audio_mixer/FSL_S_Data
add wave -noupdate -format Literal -radix binary /audio_mixer/FSL_S_Control
add wave -noupdate -format Literal -radix binary /audio_mixer/FSL_S_Exists
add wave -noupdate -format Literal -radix binary /audio_mixer/FSL_M_Write
add wave -noupdate -format Literal -radix hexadecimal /audio_mixer/FSL_M_Data
add wave -noupdate -format Literal -radix binary /audio_mixer/FSL_M_Control
add wave -noupdate -format Literal -radix binary /audio_mixer/FSL_M_Full
add wave -noupdate -divider "Internals"
add wave -noupdate -format Literal -radix binary /audio_mixer/state
add wave -noupdate -format Literal -radix binary /audio_mixer/next_state
add wave -noupdate -format Literal -radix hexadecimal /audio_mixer/input1
add wave -noupdate -format Literal -radix hexadecimal /audio_mixer/input2
add wave -noupdate -format Literal -radix hexadecimal /audio_mixer/data_output
add wave -noupdate -format Literal -radix hexadecimal /audio_mixer/mix1
add wave -noupdate -format Literal -radix hexadecimal /audio_mixer/mix2



#set clocks
force FSL_Clk 1 0 -r 20
force FSL_Clk 0 10 -r 20

#Bring system out of reset
force FSL_M_Full 0
force FSL_S_Control 0
force FSL_Rst 0
run 60 ns

#Put data on FSL
force FSL_S_Data 16'd50
force FSL_S_Exists 1

run 40 ns

#force FSL_S_Exists 0
force FSL_S_Data 16'h1234
run 20 ns

force FSL_S_Exists 1
run 20 ns

#force FSL_S_Exists 0
force FSL_S_Data 16'h4321
run 20 ns

#force FSL_S_Exists 0


#Create control signals
#for {set x 0} {$x<128} {incr x} {
#	force ctrl 7'd$x
#	run 10 ns
#}

run 200 ns
